package com.qmth.cqb.utils;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.apache.commons.lang3.StringUtils;
import org.docx4j.Docx4J;
import org.docx4j.TraversalUtil;
import org.docx4j.XmlUtils;
import org.docx4j.convert.out.html.AbstractHtmlExporter.HtmlSettings;
import org.docx4j.finders.ClassFinder;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.wml.ArrayListWml;
import org.docx4j.wml.Document;
import org.docx4j.wml.FldChar;
import org.docx4j.wml.P;
import org.docx4j.wml.R;
import org.docx4j.wml.RPr;
import org.docx4j.wml.Text;

public class ParserDocxUtils {
	
	public static void main(String[] args) throws Docx4JException{
	     parserDocx("/test/test.docx");
	}

	private static void parserDocx(String docxFilePath) throws Docx4JException {
		WordprocessingMLPackage  wordMLPackage = WordprocessingMLPackage.load(new File(System.getProperty("user.dir")+docxFilePath));
		MainDocumentPart mdp = wordMLPackage.getMainDocumentPart();
		ClassFinder finder = new ClassFinder(P.class); // <----- change this to suit
		new TraversalUtil(mdp.getContent(), finder);
		List<Object> objs = finder.results;
		List<String> pStrs = new ArrayList<String>();
		List<P> wps = new ArrayList<P>();
		//int index = 0;
		for (Object object :objs) {
				  if (object instanceof P) {
		                P p = (P) object;
		            	//wps.add(p);
		                System.out.println(XmlUtils.marshaltoString(p));
		                ClassFinder tFinder = new ClassFinder(Text.class); 
		                new TraversalUtil(p.getContent(), tFinder);
		                List<Object> tList = tFinder.results;
		                for (Object t :tList) {//排除空段落
		                	if(t instanceof Text && StringUtils.isNotEmpty(((Text) t).getValue())){
		                		wps.add(p);
		                		pStrs.add(XmlUtils.marshaltoString(p));
		                	    break;
		                	}
		                }
//		                System.out.println(t.getValue());
//		                if (t.getValue().equals("1")) {
//		                    if (objs.size() > index + 1) {
//		                        Text tnext = (Text) (objs.get(index + 1));
//		                        R r = (R) (tnext.getParent());
//		                        P p = (P) r.getParent();
//		                        System.out.println(XmlUtils.marshaltoString(p));
//		                    }
//		                }
		            }
		        }
		for(int i=0;i<pStrs.size();i++){
			
		}
		    
    }
}
